<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: Queue APIs</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Queue APIs<br/>
<small>
[<a class="el" href="group__group__tivx__api.html">1: TIOVX Interface Modules</a>]</small>
</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Structures</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structtivx__queue.html">tivx_queue</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Typedef for a queue.  <a href="structtivx__queue.html#_details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__queue.html#ga220fbb97bef3acbbb17f55b02ba4e386">tivxQueueCreate</a> (<a class="el" href="structtivx__queue.html">tivx_queue</a> *queue, uint32_t max_elements, uint32_t *queue_memory, uint32_t flags)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a queue.  <a href="#ga220fbb97bef3acbbb17f55b02ba4e386"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__queue.html#ga1f9f4c5863f9cc2b42edf051f1314310">tivxQueueDelete</a> (<a class="el" href="structtivx__queue.html">tivx_queue</a> *queue)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Delete a queue.  <a href="#ga1f9f4c5863f9cc2b42edf051f1314310"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__queue.html#ga18c7c8bf6d5f4405384bdaf1d454c9d9">tivxQueuePut</a> (<a class="el" href="structtivx__queue.html">tivx_queue</a> *queue, uint32_t data, uint32_t timeout)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Add a element into the queue.  <a href="#ga18c7c8bf6d5f4405384bdaf1d454c9d9"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__queue.html#ga7e2d85b5ee64e73cda934f514d522618">tivxQueueGet</a> (<a class="el" href="structtivx__queue.html">tivx_queue</a> *queue, uint32_t *data, uint32_t timeout)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Extract a element from the queue.  <a href="#ga7e2d85b5ee64e73cda934f514d522618"></a><br/></td></tr>
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__queue.html#ga4736bb537f0bc9b2b9cc14689da5c0e2">TIVX_QUEUE_FLAG_BLOCK_ON_PUT</a>&nbsp;&nbsp;&nbsp;(0x00000001u)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Flag to indicate queue should block 'put' operation until free space is available for 'put' to succeed.  <a href="#ga4736bb537f0bc9b2b9cc14689da5c0e2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__group__tivx__queue.html#gaf76bc1eb122ceadf7c239d4c726ee226">TIVX_QUEUE_FLAG_BLOCK_ON_GET</a>&nbsp;&nbsp;&nbsp;(0x00000002u)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Flag to indicate queue should block 'get' operation until new element is available in queue to extract.  <a href="#gaf76bc1eb122ceadf7c239d4c726ee226"></a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="ga4736bb537f0bc9b2b9cc14689da5c0e2"></a><!-- doxytag: member="tivx_queue.h::TIVX_QUEUE_FLAG_BLOCK_ON_PUT" ref="ga4736bb537f0bc9b2b9cc14689da5c0e2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TIVX_QUEUE_FLAG_BLOCK_ON_PUT&nbsp;&nbsp;&nbsp;(0x00000001u)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag to indicate queue should block 'put' operation until free space is available for 'put' to succeed. </p>

</div>
</div>
<a class="anchor" id="gaf76bc1eb122ceadf7c239d4c726ee226"></a><!-- doxytag: member="tivx_queue.h::TIVX_QUEUE_FLAG_BLOCK_ON_GET" ref="gaf76bc1eb122ceadf7c239d4c726ee226" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define TIVX_QUEUE_FLAG_BLOCK_ON_GET&nbsp;&nbsp;&nbsp;(0x00000002u)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Flag to indicate queue should block 'get' operation until new element is available in queue to extract. </p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga220fbb97bef3acbbb17f55b02ba4e386"></a><!-- doxytag: member="tivx_queue.h::tivxQueueCreate" ref="ga220fbb97bef3acbbb17f55b02ba4e386" args="(tivx_queue *queue, uint32_t max_elements, uint32_t *queue_memory, uint32_t flags)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> tivxQueueCreate </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__queue.html">tivx_queue</a> *&nbsp;</td>
          <td class="paramname"> <em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>max_elements</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&nbsp;</td>
          <td class="paramname"> <em>queue_memory</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>flags</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a queue. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>queue</em>&nbsp;</td><td>[out] Pointer to queue object </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>max_elements</em>&nbsp;</td><td>[in] Max elements in a queue </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>queue_memory</em>&nbsp;</td><td>[in] Pointer to queue memory, queue can only contain elements of size 32bits </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>flags</em>&nbsp;</td><td>[in] Flags to use during queue creation, see TIVX_QUEUE_FLAG_xxx</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>VX_SUCCESS on success </dd></dl>

</div>
</div>
<a class="anchor" id="ga1f9f4c5863f9cc2b42edf051f1314310"></a><!-- doxytag: member="tivx_queue.h::tivxQueueDelete" ref="ga1f9f4c5863f9cc2b42edf051f1314310" args="(tivx_queue *queue)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> tivxQueueDelete </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__queue.html">tivx_queue</a> *&nbsp;</td>
          <td class="paramname"> <em>queue</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Delete a queue. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>queue</em>&nbsp;</td><td>[in] Pointer to queue object</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>VX_SUCCESS on success </dd></dl>

</div>
</div>
<a class="anchor" id="ga18c7c8bf6d5f4405384bdaf1d454c9d9"></a><!-- doxytag: member="tivx_queue.h::tivxQueuePut" ref="ga18c7c8bf6d5f4405384bdaf1d454c9d9" args="(tivx_queue *queue, uint32_t data, uint32_t timeout)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> tivxQueuePut </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__queue.html">tivx_queue</a> *&nbsp;</td>
          <td class="paramname"> <em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>timeout</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a element into the queue. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>queue</em>&nbsp;</td><td>[in] Pointer to queue object </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>data</em>&nbsp;</td><td>[in] element to add </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>timeout</em>&nbsp;</td><td>[in] Amount of time to wait, TIVX_QUEUE_FLAG_BLOCK_ON_PUT msut be set during create, else function does not wait and returns error if queue is full</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>VX_SUCCESS on success </dd></dl>

</div>
</div>
<a class="anchor" id="ga7e2d85b5ee64e73cda934f514d522618"></a><!-- doxytag: member="tivx_queue.h::tivxQueueGet" ref="ga7e2d85b5ee64e73cda934f514d522618" args="(tivx_queue *queue, uint32_t *data, uint32_t timeout)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0">vx_status</a> tivxQueueGet </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtivx__queue.html">tivx_queue</a> *&nbsp;</td>
          <td class="paramname"> <em>queue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&nbsp;</td>
          <td class="paramname"> <em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>timeout</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Extract a element from the queue. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>queue</em>&nbsp;</td><td>[in] Pointer to queue object </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>data</em>&nbsp;</td><td>[out] element that is extracted </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>timeout</em>&nbsp;</td><td>[in] Amount of time to wait, TIVX_QUEUE_FLAG_BLOCK_ON_GET msut be set during create, else function does not wait and returns error if queue is empty</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>VX_SUCCESS on success </dd></dl>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
